#include<iostream>
#include<vector>
#include<algorithm>
using namespace std;
const int N = 1e5 + 5;
int n, u, w, x, y, i, j, d, p, m, r, max_p = -1, b[5];
vector<int> g[N];

void _dfs(int s, int e) {
	if (d > p) {
		p = d;
		m = s;
		r = 0;
	}
	if (d == p) {
		r++;
	}
	++d;
	for (auto u : g[s]) {
		if (u != e) _dfs(u, s);
	}
	--d;
}

bool prava(int s, int e) {
	if (g[s].size() > 2)return false;
	for (auto u : g[s]) {
		++j;
		if (u != e) return prava(u, s);
		if (j == n)return true;
	}

}

void dfs(int s) {
	d = r = p = 0;
	_dfs(s, 0);
}

int main() {
	for (i = 0, cin >> n; i < n-1; i++) {
		cin >> u >> w;
		g[u].push_back(w);
		g[w].push_back(u);
	}
	if (prava(1, 0))return cout << n - 3 + (n&1), 0;
	dfs(1);
	dfs(m);
	if ((n & 1) && r == 1) {
		dfs(m);
		if (r==1)n--;
	}
	cout << p - 1 + (n&1);
}